//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Hook into the client update messages to maintain our player list
// and scoreboard.
//-----------------------------------------------------------------------------

addMessageCallback('MsgClientJoin', handleClientJoin);
addMessageCallback('MsgClientDrop', handleClientDrop);
addMessageCallback('MsgClientScoreChanged', handleClientScoreChanged);

addMessageCallback('MsgTeamAdd', handleTeamAdd);
addMessageCallback('MsgTeamRemove', handleTeamRemove);

//-----------------------------------------------------------------------------
function handleTeamRemove(%msgType, %msgString, %teamID)
{
	lstTeamList.removeRowByID(%teamID);
}

function handleTeamAdd(%msgType, %msgString, %teamName, %teamID)
{
	%clientId = %teamID;
	%name = StripMLControlChars(detag(%teamName));
	
	if (lstTeamList.getRowNumById(%clientId) == -1)
	{
		lstTeamList.addRow(%clientId, %name);
	}
	else
	{
		lstTeamList.setRowById(%clientId, %name);
	}
}

function handleClientJoin(%msgType, %msgString, %clientName, %clientId,
   %guid, %score, %isAI, %isAdmin, %isSuperAdmin )
{
   PlayerListGui.update(%clientId,detag(%clientName),%isSuperAdmin,
      %isAdmin,%isAI,%score);

	//add players to admin list too
	%name = StripMLControlChars(detag(%clientName));
	if (lstAdminPlayerList.getRowNumById(%clientId) == -1)
	{
		lstAdminPlayerList.addRow(%clientId, %name);
	}
	else
	{
		lstAdminPlayerList.setRowById(%clientId, %name);
	}

	if (lstPlayersPlayerList.getRowNumById(%clientId) == -1)
	{
		lstPlayersPlayerList.addRow(%clientId, %name);
	}
	else
	{
		lstPlayersPlayerList.setRowById(%clientId, %name);
	}
	
	if (lstMessagePlayerList.getRowNumById(%clientId) == -1)
	{
		lstMessagePlayerList.addRow(%clientId, %name);
	}
	else
	{
		lstMessagePlayerList.setRowById(%clientId, %name);
	}

	if (lstTeamPlayerList.getRowNumById(%clientId) == -1)
	{
		lstTeamPlayerList.addRow(%clientId, %name);
	}
	else
	{
		lstTeamPlayerList.setRowById(%clientId, %name);
	}
}

function handleClientDrop(%msgType, %msgString, %clientName, %clientId)
{
   PlayerListGui.remove(%clientId);
   lstAdminPlayerList.removeRowByID(%clientId);
   lstPlayersPlayerList.removeRowByID(%clientId);
   lstMessagePlayerList.removeRowByID(%clientId);
   lstTeamPlayerList.removeRowByID(%clientId);
}

function handleClientScoreChanged(%msgType, %msgString, %score, %clientId)
{
   PlayerListGui.updateScore(%clientId,%score);
}
