//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Support function which applies damage to objects within the radius of
// some effect, usually an explosion.  This function will also optionally 
// apply an impulse to each object.

function bombradiusDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse, %rigger)
{
   // Use the container system to iterate through all the objects
   // within our explosion radius.  We'll apply damage to all ShapeBase
   // objects.
	InitContainerRadiusSearch(%position, %radius, $TypeMasks::ShapeBaseObjectType);

	%halfRadius = %radius / 2;
	while ((%targetObject = containerSearchNext()) != 0) {
		%coverage = calcExplosionCoverage(%position, %targetObject,
         	$TypeMasks::InteriorObjectType |  $TypeMasks::TerrainObjectType |
         	$TypeMasks::ForceFieldObjectType | $TypeMasks::VehicleObjectType);
      		if (%coverage == 0)
        		continue;

		%dist = containerSearchCurrRadiusDist();
	  	%distScale = (%dist < %halfRadius)? 1.0:
	      	   1.0 - ((%dist - %halfRadius) / %halfRadius);
if($Pref::Server::BTF $= 1)
{
		if(%targetObject.getClassname() $= "Player" && %targetobject.client.team != %rigger.team)
		{

%targetObject.damage(%sourceObject, %position, %damage * %coverage * %distScale, %damageType);
		
		}

}
else
{	

if(%targetObject.getClassname() $= "Player")
		{
%targetObject.damage(%sourceObject, %position, %damage * %coverage * %distScale, %damageType);
		
		}
}
		if(%targetObject.getDatablock().classname $= "Brick" && $Pref::Server::DMBreakBricks == 1)
		{	
			if($Pref::Server::BTF $= 1)
			{
			if(%targetObject.team $= %rigger.team)
			{
			messageAll('name', 'The Crystal was Blown! Team %1 Wins!', %rigger.team);
			
			for(%t = 0; %t < MissionCleanup.getCount(); %t++)
			{
			%bombObj = MissionCleanup.getObject(%t);

			if(%bombObj.bombID > 0)
			{
				%bombObj.dead = true;
				%bombObj.schedule(10, explode);
			}
			}
			
				$TotalPhoenix = 0;
				$TotalFalcon = 0;
				for(%t = 0; %t<ClientGroup.getCount(); %t++)
				{
					%cl = ClientGroup.getObject(%t);
					%cl.timerigged = 0;
					
					
					if(%cl.Team $= "Falcon")
					{
						$TotalPhoenix++;
						%cl.Team = "Phoenix";
						bottomPrint(%cl,"\"Bomb the Fort\" Another Round!\nYou will be on the Phoenix Team.\nYour aim is to blow the Falcon Team's Crystal using Dynamite! - You can Defuse the Bomb by Hitting it with your Screwdriver.\nWhen you get killed, you will be placed in the Enemy Jail. Your Team must Free you.",20,3);
					}
					else if(%cl.Team $= "Phoenix")
					{
						$TotalFalcon++;
						%cl.Team = "Falcon";
						bottomPrint(%cl,"\"Bomb the Fort\" Another Round!\nYou will be on the Falcons Team.\nYour aim is to blow the Phoenix Team's Crystal using Dynamite! - You can Defuse the Bomb by Hitting it with your Screwdriver.\nWhen you get killed, you will be placed in the Enemy Jail. Your Team must Free you.",20,3);
					}
					%cl.player.kill();
				}


			}
			}

			if(%targetObject.NoDestroy != 1)
			{


			if(%distScale == 1)
			{
				%targetObject.hits++;
				%targetObject.hits++;

			}
			else
			{
				%targetObject.hits++;
			}
			if(%targetObject.hits >= $Pref::Server::DMMaxBrickHits-2)
			{
				%targetObject.setSkinName('red');
			}
			else
			{
				%targetObject.SkinName = %targetObject.getSkinName();
			}
			if(%targetObject.hits >= $Pref::Server::DMMaxBrickHits)
			{
				%targetObject.hits = 0;
				%targetObject.startFade(0, 0, true);
				%targetObject.hide(true);
				%targetObject.setSkinName(%targetObject.SkinName);
				%targetObject.schedule($Pref::Server::DMBrickReSpawnTime*1000, "hide", false);
  				%targetObject.schedule($Pref::Server::DMBrickReSpawnTime*1000 + 100, "startFade", 1000, 0, false);
				
			}
			}
		}


      		// Apply the impulse
if($Pref::Server::BTF $= 1)
{
     		if (%impulse && %targetobject.client.team != %rigger.team)
		{
        		%impulseVec = VectorSub(%targetObject.getWorldBoxCenter(), %position);
         		%impulseVec = VectorNormalize(%impulseVec);
         		%impulseVec = VectorScale(%impulseVec, %impulse * %distScale);
         		%targetObject.applyImpulse(%position, %impulseVec);
      		}
}
else
{
     		if (%impulse)
		{
        		%impulseVec = VectorSub(%targetObject.getWorldBoxCenter(), %position);
         		%impulseVec = VectorNormalize(%impulseVec);
         		%impulseVec = VectorScale(%impulseVec, %impulse * %distScale);
         		%targetObject.applyImpulse(%position, %impulseVec);
      		}
}


    	}	

}
