//wrench.cs
$TotalMoversInGroup = 5;
//effects
datablock ParticleData(wrenchExplosionParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "~/data/particles/snowflake";
   colors[0]     = "0.0 0.7 0.9 0.9";
   colors[1]     = "0.0 0.0 0.9 0.0";
   sizes[0]      = 0.7;
   sizes[1]      = 0.2;
};

datablock ParticleEmitterData(wrenchExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "wrenchExplosionParticle";
};

datablock ExplosionData(wrenchExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   particleEmitter = wrenchExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 2.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 1;
   lightStartColor = "00.0 0.6 0.9";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(wrenchProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 10;
   radiusDamage        = 10;
   damageRadius        = 0.5;
   explosion           = wrenchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

};


//////////
// item //
//////////
datablock ItemData(wrench)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/wrench.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
        skinName = 'red';
	cost = "30";
	 // Dynamic properties defined by the scripts
	pickUpName = 'a wrench';
	invName = 'Wrench';
	image = wrenchImage;
};

//function wrench::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(wrenchImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/wrench.dts";
   PreviewFileName = "rtb/data/shapes/bricks/Previews/wrench.png";
   emap = true;
	cloakable = false;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = wrench;
   ammo = " ";
   projectile = wrenchProjectile;
   projectileType = Projectile;
	
   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};

function wrenchImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'wrench prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function wrenchImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function removeFromMoverList(%obj)
{
	for(%t = 0; %t < $TotalMoversPlaced + 1; %t++)
	{
		if(%obj == $Movers[%t])
		{
			$Movers[%t] = 0;
		}
	} 
}

function wrenchProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{

if(%obj.client.isImprisoned)
	{
		messageClient(%client,'',"\c2Trying to wrench are you?!?! Imprisoned scum...");
		return;
	}

		%player = %obj.client.player;

		//if theres no player, (or client) bail out now
		if(!%player)
			return;
		

		if (%col.getClassName() !$= "StaticShape" && %col.getClassName() !$= "Player")
			return;

		%colData = %col.getDataBlock();
		%colDataClass = %colData.classname;

		if(%colDataClass $= "brick")
		{
			
			if(%obj.client.WrenchMode == 0)
			{	
							
				if(%col.Owner == %obj.client || %obj.client.isAdmin || %obj.client.isSuperAdmin)
				{
					%obj.client.WrenchObject = %col;
					if(%col.triggerdoorID >= "1")
					{
					commandtoclient(%obj.client,'setDoorSetID', %col.triggerdoorID);			
					}
					else
					{
					commandtoclient(%obj.client,'setDoorSetID', '0');
					}
					commandtoclient(%obj.client,'OpenMoverGUI');			
					
				}				
			}
			if(%obj.client.WrenchMode == 1)
			{
				colourOwnBrick(%col,%col.getSkinName(),%obj.client);
			}
			if(%obj.client.WrenchMode == 2)
			{
				killOwnBrick(%col,%obj.client);
			}
			if(%obj.client.WrenchMode == 3)
			{
				if(%col.Hits > 0)
				{
					%col.Hits = 0;
					%col.setSkinName(%col.SkinName);
				}
			}
			if(%obj.client.WrenchMode == 4)
			{
				if(%col.Owner == %obj.client)
				{
					%col.setShapeName(%obj.client.BrickMessage);
				}
			}
	
		}
		if(%col.getClassName() $= "Player")
		{
			if(%obj.client.WrenchMode == 3)
			{
				%col.applyRepair(10);
			}
		}
	//}
}

function chainColourOwnBrick(%brick, %checkVal, %iteration, %colour, %client)
{
	//make sure there is a brick object
	if(!isObject(%brick))
	{
		//brick tree is broken somewhere
		return;
	}

	//dont recheck bricks and dont paint the baseplate
	if(%brick.checkVal == %checkVal || %brick.getDataBlock().className !$= "brick")
	{
		return;
	}

	//mark this brick as checked
	%brick.checkVal = %checkVal;

	for(%i = 0; %i < %brick.upSize; %i++)
	{
		chainColourOwnBrick(%brick.up[%i], %checkVal, %iteration++, %colour,%client);
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		chainColourOwnBrick(%brick.down[%i], %checkVal,  %iteration++, %colour,%client);
	}
	if(%brick.Owner == %client)
	{
		%brick.setSkinName(%colour);
	}
}

function colourOwnBrick(%brick,%colour,%client)
{
	//remove references to this brick from its immediate children's up/down lists
	for(%i = 0; %i < %brick.upSize; %i++)
	{
		%child = %brick.up[%i];
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		%child = %brick.down[%i];
	}
	
	//if its children have no path to the ground, chain kill em
	$currCheckVal++;
	%groundCheckVal = $currCheckVal;
	for(%i = 0; %i < %brick.upSize; %i++)
	{
		%child = %brick.up[%i];
		chainColourOwnBrick(%child, $currCheckVal++, 0, %colour,%client);
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		%child = %brick.down[%i];
		chainColourOwnBrick(%child, $currCheckVal++, 0, %colour,%client);
	}

	if(%brick.Owner == %client)
	{
		%brick.setskinname(%colour);
	}
}



function killOwnBrick(%brick,%client)
{
	//remove references to this brick from its immediate children's up/down lists
	for(%i = 0; %i < %brick.upSize; %i++)
	{
		%child = %brick.up[%i];
		removeFromDownList(%brick, %child);
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		%child = %brick.down[%i];
		removeFromUpList(%brick, %child);
	}
	
	//if its children have no path to the ground, chain kill em
	$currCheckVal++;
	%groundCheckVal = $currCheckVal;
	for(%i = 0; %i < %brick.upSize; %i++)
	{
		%child = %brick.up[%i];
		if(!hasPathToGround(%child, %groundCheckVal))
		{
			chainKillOwnBrick(%child, $currCheckVal++, 0,%client);
		}
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		%child = %brick.down[%i];
		if(!hasPathToGround(%child, %groundCheckVal))
		{
			chainKillOwnBrick(%child, $currCheckVal++, 0,%client);
		}
	}

	if(%brick.Owner == %client)
	{
		//tag this brick as dead
		%brick.dead = true;

		if(%brick.isDoor)
		{
			%brick.owner.TotalMovers--;
			removeFromMoverList(%brick);
		}

		//explode this brick
		%brick.schedule(10, explode);
		
	}
}

//kills brick and all its children
function chainKillOwnBrick(%brick, %checkVal, %iteration,%client)
{
	//make sure there is a brick object
	if(!isObject(%brick))
	{
		//brick tree is broken somewhere
		return;
	}

	//dont recheck bricks and dont kill the baseplate
	if(%brick.checkVal == %checkVal || %brick.getDataBlock().className !$= "brick")
	{
		return;
	}

	//mark this brick as checked
	%brick.checkVal = %checkVal;

	for(%i = 0; %i < %brick.upSize; %i++)
	{
		chainKillOwnBrick(%brick.up[%i], %checkVal, %iteration++,%client);
	}
	for(%i = 0; %i < %brick.downSize; %i++)
	{
		chainKillOwnBrick(%brick.down[%i], %checkVal,  %iteration++,%client);
	}
	if(%brick.Owner == %client)
	{
		//tag this brick as dead
		%brick.dead = true;

		if(%brick.isDoor)
		{
			%brick.owner.TotalMovers--;
			removeFromMoverList(%brick);
		}

		if(%iteration <= 1)
			%brick.schedule((%iteration * 25) + 0, explode);
		else
			%brick.schedule((%iteration * 25) + 50, explode);
	}
}



function setdoortomover(%client)
{

%col = %client.WrenchObject;

if(%col.isDoor != 1)
{
									
	if(%client.TotalMovers < $Pref::Server::MaxDoors)
	{
										
		%col.isDoor = 1;
		%col.isPrivateDoor = %client.WrenchPrivate;
		%col.isTeamDoor =  %client.WrenchTeam;
		%col.teamDoor = %client.team;
		%col.isElevator = %client.WrenchElevator;
		%bricksHigh = %client.WrenchMoveZ;
		%bricksWide = %client.WrenchMoveY;
	%bricksLong = %client.WrenchMoveX;
	%col.doorsteps = %client.WrenchSteps;
		%col.doortime = %client.WrenchStepTime;
		%col.doorx = (%bricksLong*0.5)/(%col.doorsteps+1);
		%col.doory = (%bricksWide*0.5)/(%col.doorsteps+1);
		%col.doorz = (3*(%bricksHigh*0.2))/(%col.doorsteps+1);
		%rotX = getWord(%client.WrenchRot,0) / %col.doorsteps;
		%rotY = getWord(%client.WrenchRot,1) / %col.doorsteps;
		%rotZ = getWord(%client.WrenchRot,2) / %col.doorsteps;
		%col.doorRot = %rotX SPC %rotY SPC %rotZ;
		%col.doorReturnPause = %client.WrenchReturnPause;
							
		if(%client.WrenchToggleReturn)
		{
			%col.doorreturn = 0;
			%col.doorToggleReturn = 1;
			%col.doorHasReturned = 1;
		}
		else
		{
		%col.doorreturn = 1;
		}

							%col.noCollisionMove = %client.WrenchnoCollision;
							if(%col.doorx == 0 && %col.doory == 0&& %col.doorz == 0 && %col.doorRot $= "0 0 0")
							{
							%col.doorsteps = 0;
							%col.doortime = 0;
							}

							if(%client.WrenchPasswordYN)
							{
							%col.DoorPassword = %client.WrenchPassword;
							%col.Passworded = 1;
							}
							else
							{
							%col.Passworded = 0;
							}

							if(%client.WrenchTriggeredDoor)                     				
							{
							%col.triggereddoor = 1;
							%col.triggerdoorID = %client.WrenchDoorSetID;
							}
							if(%client.WrenchTrigger)
							{
							%col.isTrigger = 1;
							%col.triggerdoorID = %client.WrenchDoorSetID;
							}
			 
							$Movers[$TotalMoversPlaced++] = %col;
							%client.TotalMovers++;
							commandtoclient(%client,'CloseMoverGUI');	
							messageClient(%client,"","\c2Gave Brick Movement Properties");
						}
						else
						{
							if($Pref::Server::MaxDoors == 0)
							{
							commandtoclient(%client,'CloseMoverGUI');	
								messageClient(%client,"","\c2Movers not allowed on this server");
							}
							else
							{
							commandtoclient(%client,'CloseMoverGUI');	
								messageClient(%client,"","\c2Can't set any more movers");
								messageClient(%client,"",'\c2There is a limit of %1',$Pref::Server::MaxDoors);

							}
						}
					}
					else
					{	
						messageClient(%client,"","\c2This Brick already has Movement Properties! Please Remove Them!");
					}

}
